﻿using C1.WPF.PropertyGrid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PropertyGrid_ListCustomEditor
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            var children = new ObservableCollection<Person>();
            children.Add(new Person() { Name = "Mike" });
            children.Add(new Person() { Name = "Julia" });
            propertyGrid.SelectedObject = new Person()
            {
                Name = "John",
                Children = children
            };
            propertyGrid.PropertyAttributes.Add(new PropertyAttribute()
            {
                MemberName = "Children",
                Editor = new ListCustomEditor()
            });
        }
    }
    public class ListCustomEditor : ListBox, ITypeEditorControl
    {
        public event PropertyChangedEventHandler ValueChanged;
        public void Attach(PropertyAttribute property)
        {
            if (Supports(property))
            {

                this.ItemsSource = (property.SelectedObject as Person).Children;
                this.ItemTemplate = FindResource("listTemplate") as DataTemplate;
                this.HorizontalContentAlignment = HorizontalAlignment.Stretch;
            }
        }

        public ITypeEditorControl Create()
        {
            return this;
        }
        public bool Supports(PropertyAttribute Property)
        {
            return Property.PropertyInfo.PropertyType == typeof(ObservableCollection<Person>);
        }
        public void Detach(PropertyAttribute property)
        {
            // Detach method 
        }


    }
    class Person
    {
        public string Name { get; set; }
        public ObservableCollection<Person> Children { get; set; }
    }

}
